package domain

// ===================交易種類===================

type TxType int64

// 交易類型
const (
	// TxDepositType 充值(增加可用餘額)
	TxDepositType TxType = iota + 1

	// TxWithdrawType 提現(減少可用餘額)
	TxWithdrawType

	// TxFreezeType 凍結(減少可用餘額，加在凍結餘額)
	TxFreezeType

	// TxUnFreezeType 解凍(減少凍結餘額)
	TxUnFreezeType

	// TxRollbackFreezeType rollback凍結(減少凍結餘額，加回可用餘額，不可指定金額)
	TxRollbackFreezeType

	// TxUnconfirmedType 限制(減少凍結餘額，加別人限制餘額)
	TxUnconfirmedType

	// TxCancelFreezeType 取消凍結(減少凍結餘額，加回可用餘額，，可指定金額)
	TxCancelFreezeType

	// TxDepositUnconfirmedType 充值(增加限制餘額)
	TxDepositUnconfirmedType

	// TxAppendFreezeType 追加凍結(減少可用餘額，加在凍結餘額)
	TxAppendFreezeType

	// TxRollbackFreezeAddAvailableType rollback凍結(rollback凍結餘額，指定金額加回可用餘額)
	TxRollbackFreezeAddAvailableType

	// TxDistributionType 平台分發
	TxDistributionType

	// TxSystemTransfer 系統劃轉
	TxSystemTransfer
)

func (t TxType) ToInt() int64 {
	return int64(t)
}
